### About CALAMARI

CALAMARI is a primitive diff/merge tool for raster images. It is based
on the idea of comparing the color value of each pixel in one or more
images to the color value of a corresponding pixel in a counterpart
image of equal dimensions.

A while back I gave a talk on integrating and merging that used simple
raster images to represent files and diffs. The images made it easy to
get the concepts across, but all of the merge results had to be mocked
up by hand, making it impossible to demonstrate the examples with a real
Perforce server. CALAMARI was written as a way of playing a bit more
with this idea and making it easier to generate these types of examples,
as well as opening the possibility of using them in a live demo. It is
also very occasionally useful when working with images in Perforce.

### Command line invocation

To use CALAMARI as a diff tool:

`calamari IMAGE1 IMAGE2`

To use CALAMARI as a merge tool:

`calamari BASE THEIRS YOURS [RESULT]`

### The interface

For a complete description of each interface element, see the online
help that's bundled with CALAMARI.

The following screenshot shows the merge tool mode being used to merge
changes to an MS Paint drawing of a squid:

![](Calamari-screen.png "Calamari-screen.png")

A step-by-step walkthrough of this example merge is given
[here](http://www.leadtogold.com/software/calamari/demo.html).

[Category:Image diff/merge
tools](Category:Image_diff/merge_tools "wikilink")
