{{ Project | Multithreaded Weekly Distributed Depot Verify |

`  curator  = Kirk McCann and Luke Howell                    |`\
`  path     = //guest/kirk_mccann/Multithreaded_Verify/          |`\
`  download = //guest/kirk_mccann/Multithreaded_Verify/p4verify_step2_runverify.cc |`\
`  language = C++                |`\
`  license  = GPL                                 }}`

### About This Project

This project was created to perform a P4 verify against all the depots
in a perforce instance on a regular basis without the burden of a long
downtime.\
\
 **This code does this in these steps:**

1.  Check to see if its a new week\
2.  Read the log to determine what Depots have been Verified by this
    process this week\
3.  Get a list of all the Depots\
    \#While getting the list of depots the verified depots are filtered
    out\
4.  (Multithreaded) Get the number of files and the size of each Depot\
5.  Sort all the Depots by Size\
6.  Distribute the unverified depots across the remaining days it is
    scheduled to run\
7.  (Multithreaded) Verify the depots that have been allocated to run
    today\
8.  Log the depots that were verified\

\
\
**The following variables may need to be modified before compiling:**\
\*LOG\_FILE "/var/log/p4verify\_log"\
\*\*The location of the verify log file\
\*ERROR\_LOG "/var/log/p4verify\_error\_log"\
\*\*The location of the error log file.\
\*PASSWD\
\*\*The token for the perforce account\
\*PORT\
\*\*The host:port for the perforce server\
\*USERNAME\
\*\*The username that will be used to perform the perforce commands\
\*WEEKLY\_START\_DAY\
\*\*The number that will be used as the first day of the week\
\*WEEKLY\_END\_DAY\
\*\*The number that will be used as the end of the week\
\*NUM\_WEEKLY\_RUNS\
\*\*The number of days the process will run\
\*DAYS\_TO\_RUN\
\*\*A numerical list of the days that the process will run\
\*NUM\_THREADS\
\*\*Number of threads to use when getting size and verifying the depots\
\*\*This number needs to be adjusted based on the number and speed of
your processors and the speed of your storage device. If this number is
too high the bandwidth to your storage device may become overloaded.\
\
\
 {{ License | GPL | 2012 | Kirk McCann and Luke Howell }}

{{ RecentChanges | //guest/kirk\_mccann/Multithreaded\_Verify/ }}

[Category:Perforce administrative
tools](Category:Perforce_administrative_tools "wikilink")
