{{ Project | P4 Shelve |

`  curator       = Chris Stoy |`\
`  path          = //guest/chris_stoy/p4_shelve/ |`\
`  download      = //guest/chris_stoy/p4_shelve/ |`\
`  documentation = //guest/chris_stoy/p4_shelve/readme.txt |`\
`  language      = Python |`\
`  license       = See below }}`

### Notes

To use these scripts with [current versions of
P4Python](http://www.perforce.com/perforce/doc.current/user/p4pythonnotes.txt),
you will need to remove the `p4c.parse_forms()` calls, as this function
is no longer present in the GA version of the API.

See also [p4tar](p4tar "wikilink"), which can be used to "shelve" a
changelist by packaging it on the client rather than by checking it into
the depot.

### Usage

`Usage: p4_shelve [options]`\
\
`Shelves a changelist for later editing.`\
\
`Shelving a changelist will create a branch of the files in the`\
`current changelist and move all the changes to that branch. It`\
`will then revert the files in the current changelist while preserving`\
`any changes in the branch.`\
\
`Use 'p4_unshelve' to restore a shelved changelist.`\
\
`Options:`\
`  -h, --help         Prints this help message`\
`  -v, --verbose      Prints verbose messages while shelving`\
`  -p, --port         Perforce Port depot is on`\
`  -c, --client       Perforce Client that maps the depot files`\
`  -u, --user         Perforce User that owns the client`\
`  -P, --password     Perforce Password for the user`\
`  -e, --changelist   Perforce Change List ID to shelve`\
`  -s, --shelfroot    Depot path where the shelved files should go. `\
\
`Note: Uses the default P4 settings for Perforce options not supplied.`

`Usage: p4_unshelve [options] `<shelve branchspec>\
\
`Restores a shelved changelist into the default changelist for editing. `\
\
`  `<shelve branchspec>`  Perforce branchspec created by p4_shelve.`\
\
`Options:`\
`  -h, --help         Prints this help message`\
`  -p, --port         Perforce Port depot is on`\
`  -c, --client       Perforce Client that maps the depot files`\
`  -u, --user         Perforce User that owns the client`\
`  -P, --password     Perforce Password for the user`\
\
`Note: Uses the default P4 settings for Perforce options not supplied.`

### License

`#   Copyright 2005, Chris Stoy.  All Rights Reserved.`\
`#`\
`#   License:`\
`#   This file and any derivatives or translations of it may be freely`\
`#   copied and redistributed so long as:`\
`#       1) This license and copyright notice are not changed.`\
`#       2) Any fixes or enhancements are reported back to either the`\
`#           author (cstoy@nc.rr.com).`\
`#   and any of:`\
`#       a) The source is redistributed with it.`\
`#       b) The source is compiled unmodified, and instructions for finding`\
`#           the original source are included.`\
`#       c) The source is made available by some other means.`

{{ RecentChanges | //guest/chris\_stoy/p4\_shelve/... }}

### Variants

{{\#p4variants://guest/chris\_stoy/p4\_shelve/...}}

{{\#p4variants://guest/shawn\_hladky/p4\_shelve/...}}

<Category:Perforce>
