Visual SourceSafe to Perforce Migration
---------------------------------------

### About This Project

Also known as Vss2P4

#### Content

Source and documentation for Perforce's VssToP4 scripts - Perl scripts
to migrate a repository from Microsoft's Visual SourceSafe into
Perforce. See

-   

This set of Perl scripts converts VSS archives to Perforce, preserving
the original times and authors. Branches are translated verbatim,
individual file revisions are grouped as much as possible into
Perforce's notion of atomic changes.

Handles VSS 6.x or VSS 2005 format repositories.

Requires Perl 5.20, VSS 5.0 or later and Perforce 2004.2 or later([an
earlier version supports 2003.2 or earlier
servers](#Perforce_Server_Versions_before_2004.2 "wikilink")). The
scripts only run on Windows (read values from Registry).

Basic Files required to download are (see for more info):

-   [ActiveState Perl 5.20 - 32 bit
    version](http://www.activestate.com/activeperl) (Note: other
    versions not tested)
-   (source files for conversion)

-   [P4Perl](https://swarm.workshop.perforce.com/projects/p4perl/)
    (Click download button in lower left and save as Zip file)
-   [P4 API for MinGW - compatible with ActiveState Perl 32 bit
    version](ftp://ftp.perforce.com/perforce/r14.1/bin.mingwx86/p4api.zip)

You will need to build P4Perl using instructions in [P4 Perl Release
Notes](https://swarm.workshop.perforce.com/files/guest/perforce_software/p4perl/docs/p4perlnotes.txt).

These scripts are not fully supported - but feel free to contact Curator
below.

There are a couple of utilities available at: which will help with
reporting on branched and deleted files in VSS

##### Perforce Server Versions before 2004.2

See for a version of the scripts for older servers (2004.2 introduced
support for filenames containing '\#' or '@'). Please note this version
requires a different version of P4Perl - see readme.html for link.

#### Curator

. Please email **robert at vaccaperna.co.uk** if you have submitted
contributions you'd like published, or if you have ideas for
enhancement.

### Details

See the file. All files are downloadable from the Workshop (see links
above).

### Alternatives

VIZIM Worldwide has a VSS converter with the following advantages:

-   Much, much faster (reads the VSS data files directly)
-   Can cope with large repositories (40+Gb)
-   More robust (most VSS corruptions are handled seemlessly)
-   Handles VSS 2005 version databases
-   Handles shared and pinned files seemlessly

See [VIZIM Migration
services](http://www.vizim.com/services/migrations/index.html) for more
details.

### Updated

See file.

\_\_NOTOC\_\_

<Category:Perl> [Category:Perforce conversion
tools](Category:Perforce_conversion_tools "wikilink")
