### About This Project

#### Content

Source and documentation for Perforce's WebKeeper, an Apache Web Server
module providing browser access to Perforce depots.

#### Curator

Stephen Vance. Please email <steve@vance.com> if you have submitted
contributions you'd like published, if you have ideas for enhancement,
or if you have preferences among the potential enhancements listed
below.

#### Source

Click for source files.

### In Progress

-   Add basic authentication against Perforce user database as
    alternative to user and password in httpd.conf.

### Updated April 30, 2001

-   Add version string to the Apache start string for visible evidence
    during startup.

### Updated September 27, 2001

-   Add apxs build, primarily to allow easier builds for binary
    distributions and to address EAPI warnings on Red Hat. Thanks to
    Kyle Vanderbeek for the basis of this change.
-   Fix array management bug.

### Updated September 23, 2001

-   Added WebKeepRefresh directive to assist with content that is not
    directly requested by a browser, such as PHP includes.

### Updated September 4, 2001

-   Builds using Apache 1.3 APACI structure
-   Updated to Apache 1.3 API
-   Supports both static configurations and loadable modules
-   Enhanced documentation for new options and common configurations
-   New WebKeepSync directive to facilitate server-side scripting like
    PHP, server-side includes and Perl
-   New WebKeepDirectoryIndex directive to flexibly complement Apache
    DirectoryIndex
-   Built and tested on several version of Red Hat Linux and FreeBSD.

### Potential Enhancements

The following enhancements are being considered for future versions. If
you have a preference or if you have an idea that is not on the list,
please contact the curator.

-   Add support for mass virtual hosting, analogous to
    mod\_vhost\_alias functionality.
-   Add binary loadable modules to the depot for ease of installation.
-   Port to other platforms. Most prominent are probably Solaris
    and Windows. This depends on platform availability and updates to
    compilers for P4API builds. Please contact the curator.
-   Add WebKeepScriptAlias to eliminate some redundant mappings for
    /cgi-bin and the like.
-   Reduce the number of errors logged to the Apache logs.
-   Add WebDAV support for direct submission to the depot.
-   Add directory listing capability.
-   Port as an ISAPI filter for IIS.
-   Increased integration with application servers, including the major
    J2EE servers and Zope.
-   Add availability of P4 environment variables to execution contexts.
-   Support Apache 2.0.

\_\_NOTOC\_\_

[Category:Perforce
integrations](Category:Perforce_integrations "wikilink")
[Category:Perforce web
interfaces](Category:Perforce_web_interfaces "wikilink")
<Category:C/C++>
